package java.awt.peer;

import sun.java2d.pipe.Region;
import java.awt.AWTException;
import java.awt.BufferCapabilities;
import java.awt.GraphicsConfiguration;
import java.awt.image.ImageObserver;
import java.awt.image.VolatileImage;
import java.awt.Image;
import java.awt.image.ImageProducer;
import java.awt.Component;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Font;
import java.awt.image.ColorModel;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.PaintEvent;
import java.awt.AWTEvent;
import java.awt.Graphics;

public interface ComponentPeer
{
    public static final int SET_LOCATION = 1;
    public static final int SET_SIZE = 2;
    public static final int SET_BOUNDS = 3;
    public static final int SET_CLIENT_SIZE = 4;
    public static final int RESET_OPERATION = 5;
    public static final int NO_EMBEDDED_CHECK = 16384;
    public static final int DEFAULT_OPERATION = 3;
    
    public abstract boolean isObscured();
    
    public abstract boolean canDetermineObscurity();
    
    public abstract void setVisible(boolean p0);
    
    public abstract void setEnabled(boolean p0);
    
    public abstract void paint(Graphics p0);
    
    public abstract void print(Graphics p0);
    
    public abstract void setBounds(int p0, int p1, int p2, int p3, int p4);
    
    public abstract void handleEvent(AWTEvent p0);
    
    public abstract void coalescePaintEvent(PaintEvent p0);
    
    public abstract Point getLocationOnScreen();
    
    public abstract Dimension getPreferredSize();
    
    public abstract Dimension getMinimumSize();
    
    public abstract ColorModel getColorModel();
    
    public abstract Graphics getGraphics();
    
    public abstract FontMetrics getFontMetrics(Font p0);
    
    public abstract void dispose();
    
    public abstract void setForeground(Color p0);
    
    public abstract void setBackground(Color p0);
    
    public abstract void setFont(Font p0);
    
    public abstract void updateCursorImmediately();
    
    public abstract boolean requestFocus(Component p0, boolean p1, boolean p2, long p3, CausedFocusEvent.Cause p4);
    
    public abstract boolean isFocusable();
    
    public abstract Image createImage(ImageProducer p0);
    
    public abstract Image createImage(int p0, int p1);
    
    public abstract VolatileImage createVolatileImage(int p0, int p1);
    
    public abstract boolean prepareImage(Image p0, int p1, int p2, ImageObserver p3);
    
    public abstract int checkImage(Image p0, int p1, int p2, ImageObserver p3);
    
    public abstract GraphicsConfiguration getGraphicsConfiguration();
    
    public abstract boolean handlesWheelScrolling();
    
    public abstract void createBuffers(int p0, BufferCapabilities p1) throws AWTException;
    
    public abstract Image getBackBuffer();
    
    public abstract void flip(int p0, int p1, int p2, int p3, BufferCapabilities.FlipContents p4);
    
    public abstract void destroyBuffers();
    
    public abstract void reparent(ContainerPeer p0);
    
    public abstract boolean isReparentSupported();
    
    public abstract void layout();
    
    public abstract void applyShape(Region p0);
    
    public abstract void setZOrder(ComponentPeer p0);
    
    public abstract boolean updateGraphicsData(GraphicsConfiguration p0);
}
